package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.Trace;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/* loaded from: com_ynet_life_action.jar:com/ynet/life/action/AddContextFieldsToICollAction.class */
public class AddContextFieldsToICollAction extends LifeAction {
    private static final String FIELD_SEPERATOR = "||";
    private String iCollName;
    private List strDataName;

    public String execute(Context context) throws GENEException {
        try {
            IndexedCollection icoll = context.getDataElement(this.iCollName);
            KeyedCollection kcoll = new KeyedCollection();
            copyFieldsIntoKeyedCollection(context, kcoll);
            icoll.add(kcoll);
            return "0";
        } catch (GENEException ex) {
            Trace.logError("LifeAction", "添加数据集合异常", ex);
            throw ex;
        }
    }

    private void copyFieldsIntoKeyedCollection(Context context, KeyedCollection kColl) {
        if (this.strDataName != null) {
            for (String fieldName : this.strDataName) {
                kColl.put(fieldName, context.get(fieldName));
            }
        }
    }

    public void setICollName(String iCollName) {
        this.iCollName = iCollName;
    }

    public void setStrDataName(String strDataName) {
        List result = new ArrayList();
        StringTokenizer toke = new StringTokenizer(strDataName, FIELD_SEPERATOR);
        while (toke.hasMoreElements()) {
            String input = ((String) toke.nextElement()).trim();
            result.add(input);
        }
        this.strDataName = result;
    }
}
